.module Interrupt
	
	Base = Platform == TI8X ? $98 : $82
	Table = (Base << 8) + $200
	Location = Base | (Base << 8)
		
	InterruptCode
	
	.relocate Location
	
		exx ; Switch to shadow registers
		
		pop hl
		ld (OldSP),sp
		ld (OldPC),hl
		
		StoreOldRegisters = $+1 \ ld sp,0 ; NB: Points at END of buffer
		
		exx ; Switch back to regular registers

		push iy
		push ix
		push hl
		push de
		push bc
		push af
		
		OldSP = $+1 \ ld hl,0 \ push hl
		OldPC = $+1 \ ld hl,0 \ push hl
			
		exx ; Shadow registers once more
		ex af,af'
		
		CurrentThreadStore = $+1 \ ld hl,0
		ld e,(hl) \ inc hl
		ld d,(hl) \ inc hl
		ld (CurrentThreadStore),hl
		ld a,d
		or e
		jr nz,FoundOutNextThread
		ld hl,Parent.ThreadStores
		ld (CurrentThreadStore),hl
		ld e,(hl) \ inc hl
		ld d,(hl)
	FoundOutNextThread	
		ld (NextThreadToRun),de
		
		exx ; Regular registers
		ex af,af'
		
		NextThreadToRun = $+1 \ ld sp,0
		
		pop hl \ ld (NewPC),hl
		pop hl \ ld (NewSP),hl
		
		pop af
		pop bc
		pop de
		pop hl \ ld (NewHL),hl
		pop ix
		pop iy
		
		ld (StoreOldRegisters),sp
		
		NewSP = $+1 \ ld sp,0
		NewPC = $+1 \ ld hl,0 \ push hl
		NewHL = $+1 \ ld hl,0
		

		exx ; Shadow registers
		ex af,af'
		jp $3A
		
		
	.endrelocate
	
	InterruptCodeEnd
		
.endmodule


	
	
	

